xquery version "3.1";

module namespace commons="http://emo-viewer.sub.uni-goettingen.de/ns/commons";

import module namespace requestr="http://exquery.org/ns/request";

declare variable $commons:version := "1.0.0";
declare variable $commons:server := if(requestr:hostname() = "existdb") then doc("../expath-pkg.xml")/*/@name => replace("/$", "") else "http://localhost:8094/exist/restxq";
declare variable $commons:sampledata-dir := "/db/apps/emo-viewer/data/sampledata";

declare variable $commons:responseHeader200 :=
    <rest:response>
        <http:response xmlns:http="http://expath.org/ns/http-client" status="200">
            <http:header name="Access-Control-Allow-Origin" value="*"/>
        </http:response>
    </rest:response>;
    
declare variable $commons:responseHeader404 :=
    <rest:response>
        <http:response xmlns:http="http://expath.org/ns/http-client" status="404">
            <http:header name="Access-Control-Allow-Origin" value="*"/>
        </http:response>
    </rest:response>;

(:~
 : The server is inserted dynamically because it depends on the context of the
 : caller.
 : "api" can occur either at the beginning of a yet unfinished URI (in which
 : case we want to prefix it with a server) or within an URI that already
 : complete (in which case we want to leave it as it is).
 : To prevent the latter case from being replaced we temporarily change "/api/"
 : to "/API/" so that the REGEX responsible for prefixing the server doesn't
 : match these cases.
 :)
declare function commons:add-server-as-link-prefix($json-as-string as xs:string,
$server as xs:string) as item() {
    replace($json-as-string, "/api/", "/API/")
    => replace("api/", $server || "/api/")
    => replace("/API/", "/api/")
    => parse-json()
};