xquery version "3.1";

(: the target collection into which the app is deployed :)
declare variable $target external;

(
    (:  set admin password on deployment. Convert to string
    so local development will not fail because of missing
    env var. :)
    if(environment-variable("EXIST_ADMIN_PW_RIPEMD160"))
    then
        (update replace doc('/db/system/security/exist/accounts/admin.xml')//*:password/text() with text{ string(environment-variable("EXIST_ADMIN_PW_RIPEMD160")) },
         update replace doc('/db/system/security/exist/accounts/admin.xml')//*:digestPassword/text() with text{ string(environment-variable("EXIST_ADMIN_PW_DIGEST")) })
    else (: we do not have the env vars available, so we leave the configuration as it is :) 
        true() 

),
(
    (: register REST APIs :)
    for $uri in (collection($target)/base-uri())[ends-with(., ".xqm")]
        let $content := $uri
            => util:binary-doc()
            => util:base64-decode()
        let $isRest :=
            if(contains($content, "%rest:")) then
                true()
            else
                false()
    where $isRest
        return
            exrest:register-module(xs:anyURI($uri))
),
(
    (: set owner and mode for testtrigger module :)
    let $app-base := "/db/apps/emo-viewer"
    let $path := $app-base || "/modules/trigger-tests.xqm"
    return
        (
            sm:chown($path, "admin"),
            sm:chmod($path, "rwsrwxr-x")
        )
)