xquery version "3.1";

(:~
 : Test module for the RESTXQ endpoints of the sample implementation of the
 : aapitationAPI.
 : 
 : @author Michelle Weidling
 : @version 0.1.0
 :)

module namespace aapi-tests="http://emo-viewer.sub.uni-goettingen.de/ns/aapi/tests";

declare namespace http = "http://expath.org/ns/http-client";
declare namespace tei="http://www.tei-c.org/ns/1.0";

import module namespace map="http://www.w3.org/2005/xpath-functions/map";
import module namespace aapi="http://emo-viewer.sub.uni-goettingen.de/ns/aapi" at "../modules/annotationapi.xqm";
import module namespace test="http://exist-db.org/xquery/xqsuite" at "resource:org/exist/xquery/lib/xqsuite/xqsuite.xql";
import module namespace aux="http://emo-viewer.sub.uni-goettingen.de/ns/aux" at "aux.xqm";

declare variable $aapi-tests:restxq := "http://0.0.0.0:8080/exist/restxq";
declare variable $aapi-tests:sampledata-ep := "http://0.0.0.0:8080/exist/restxq/sampledata/collection";
declare variable $aapi-tests:testdata-coll := "/db/apps/emo-viewer/data/testData";

declare variable $aapi-tests:collection-url := $aapi-tests:sampledata-ep || "/annotationCollection.json";
declare variable $aapi-tests:manifest-url := $aapi-tests:sampledata-ep || "/document1/manifest.json";
declare variable $aapi-tests:item-url := $aapi-tests:sampledata-ep || "/document1/1/latest/item.json";
declare variable $aapi-tests:content-url := $aapi-tests:sampledata-ep || "/document1/1/latest/content.html";
declare variable $aapi-tests:full-url := $aapi-tests:sampledata-ep || "/document3/full.json";

declare
    %test:assertTrue
function aapi-tests:is-collection-annotationCollection-available() as item() {
    aux:is-endpoint-http200($aapi-tests:sampledata-ep || "/annotationCollection.json")
};

declare
    %test:assertTrue
function aapi-tests:has-collection-annotationCollection-correct-content() as item() {
    aux:are-endpoint-data-and-control-file-equal("collection", "", "annotationCollection")
};

declare
    %test:assertXPath("map:contains($result, '@context')")
    %test:assertXPath("map:contains($result, 'id')")
    %test:assertXPath("map:contains($result, 'type')")
    %test:assertXPath("map:contains($result, 'label')")
    %test:assertXPath("map:contains($result, 'total')")
    %test:assertXPath("map:contains($result, 'first')")
    %test:assertXPath("map:contains($result, 'last')")
function aapi-tests:collection-annotationCollection-are-all-required-fields-set() {
    let $url := $aapi-tests:sampledata-ep || "/annotationCollection.json"
    return
        aux:get-json-from-url($url)
};

declare
    %test:assertTrue
function aapi-tests:is-manifest-annotationCollection-available() as item() {
     aux:is-endpoint-http200($aapi-tests:sampledata-ep || "/document1/annotationCollection.json")
};

declare
    %test:assertTrue
function aapi-tests:is-manifest-annotationPage-available() as item() {
    aux:is-endpoint-http200($aapi-tests:sampledata-ep || "/document1/annotationPage.json")
};

declare
    %test:assertTrue
function aapi-tests:has-manifest-annotationCollection-correct-content() as item() {
    aux:are-endpoint-data-and-control-file-equal("document1", "", "annotationCollection")
};

declare
    %test:assertTrue
function aapi-tests:has-manifest-annotationPage-correct-content() as item() {
    aux:are-endpoint-data-and-control-file-equal("document1", "", "annotationPage")
};

declare
    %test:assertTrue
function aapi-tests:is-item-annotationCollection-available() as item() {
    aux:is-endpoint-http200($aapi-tests:sampledata-ep || "/document1/1/annotationCollection.json")
};

declare
    %test:assertTrue
function aapi-tests:is-item-annotationPage-available() as item() {
    aux:is-endpoint-http200($aapi-tests:sampledata-ep || "/document1/1/annotationPage.json")
};

declare
    %test:assertTrue
function aapi-tests:has-item-annotationCollection-correct-content() as item() {
    aux:are-endpoint-data-and-control-file-equal("document1", "1", "annotationCollection")
};

declare
    %test:assertTrue
function aapi-tests:has-item-annotationPage-correct-content() as item() {
    aux:are-endpoint-data-and-control-file-equal("document1", "1", "annotationPage")
};
