xquery version "3.1";

(:~
 : Test module for the RESTXQ endpoints of the sample implementation of the
 : aapitationAPI.
 : 
 : @author Michelle Weidling
 : @version 0.1.0
 :)

module namespace commons-tests="http://emo-viewer.sub.uni-goettingen.de/ns/commons/tests";

declare namespace http = "http://expath.org/ns/http-client";

import module namespace map="http://www.w3.org/2005/xpath-functions/map";
import module namespace commons="http://emo-viewer.sub.uni-goettingen.de/ns/commons" at "../modules/commons.xqm";
import module namespace test="http://exist-db.org/xquery/xqsuite" at "resource:org/exist/xquery/lib/xqsuite/xqsuite.xql";

declare variable $commons-tests:restxq := "http://0.0.0.0:8080/exist/restxq";
declare variable $commons-tests:sampledata-ep := "http://0.0.0.0:8080/exist/restxq/sampledata";
declare variable $commons-tests:testdata-coll := "/db/apps/emo-viewer/data/testData";

declare variable $commons-tests:collection-url := $commons-tests:sampledata-ep || "/annotationCollection.json";
declare variable $commons-tests:manifest-url := $commons-tests:sampledata-ep || "/document1/manifest.json";
declare variable $commons-tests:item-url := $commons-tests:sampledata-ep || "/document1/1/latest/item.json";
declare variable $commons-tests:content-url := $commons-tests:sampledata-ep || "/document1/1/latest/content.html";
declare variable $commons-tests:full-url := $commons-tests:sampledata-ep || "/document3/full.json";


declare
    %test:assertXPath("map:get($result, 'annotationCollection') => starts-with('http')")
function commons-tests:add-server-as-link-prefix() {
    let $json-as-string :=
        util:binary-doc($commons-tests:testdata-coll || "/collection.json")
        => util:base64-decode()
    return 
        commons:add-server-as-link-prefix($json-as-string, $commons-tests:restxq)
};